// C Source File
// Created 03/10/2003; 19:42:23 by Bastien JANSEN

#define USE_TI89              // Compile for TI-89
#define USE_TI92PLUS          // Compile for TI-92 Plus
#define USE_V200              // Compile for V200

#define OPTIMIZE_ROM_CALLS    // Use ROM Call Optimization

#define MIN_AMS 101           // Compile for AMS 1.01 or higher

#include <tigcclib.h>         // Include All Header Files
#include "inputStr.h"					// to request some strings
#include "getArgs.h"					// to separe command from argument(s)
/*               Lin4Ti
	A LINUX-like shel for TI89/TI92+/V200
	
	Available commands : exit, off, +, -, mkdir, clear, dir, help, ren, cp, del, cd, cd.., rm, echo
*/
void _main(void)
{
	unsigned short BatteryState(unsigned short is_hw_2);
	LCD_BUFFER LCD_buff;
	LCD_save(LCD_buff);
	BOOL exit_from_prog=FALSE; // true if a program was started within Lin4Ti
	short font=F_4x6;
	// all available commands; if command isn't here, Lin4Ti will display "Commande incorrecte"
	// IMPORTANT !!! if you add a command, do not forget to increase the max value of i after the do...while loop!!!
	char availableCmds[20][7]={"exit", "off", "+", "-", "mkdir", "clear", "dir", "help",\
	 "ren", "cp", "del", "cd", "cd..", "rm", "batt", "mv", "echo", "run", ""};
	char argsList[5][75]={"", "", "", "", ""};
	clrscr();
	ST_batt(2);
	FontSetSys(font);
	
	char dir[9]="main";
	printf("Lin4Ti, une version Linux pour TI\n\n");
	printf("Build 0.40 par Bastien JANSEN\nbastien.jansen@wanadoo.fr\n\n");
	ST_showHelp("Bienvenue!");
	int max;
	
	debut:
	max=75;
	char args[max];
	SCR_STATE ss;
  args[0] = 0;
  if(exit_from_prog) exit_from_prog=FALSE;
  else{
		printf("[pingoui@ti.%s]",dir);
		SaveScrState (&ss);
  }
	if(inputStr(ss, args, max)==KEY_ESC)goto end;
	getArgs(args, argsList);
	char cmd[8];
	strcpy(cmd, &argsList[0][0]);
	char arg[]="";
	////////////////		Aliases		///////////////////
	if(!strcmp(cmd, "ls"))strcpy(cmd, "dir");
	///////////////////////////////////////////////
	int pos=-1;	
	while(pos<19 && strcmp(cmd,&availableCmds[++pos][0]));
	SYM_ENTRY *SymPtr;
	short batt;
	char file[18];
	char file_dest[18];
	switch (pos)
	{
//exit
		case 0:
			goto end;
//off
		case 1:
			off();
			printf("\n");
			goto debut;
//+
		case 2:
			if(font==F_4x6)font=F_6x8;
			else if(font==F_6x8)font=F_8x10;
			FontSetSys(font);
			printf("\n");
			goto debut;
//-
		case 3:
			if(font==F_8x10)font=F_6x8;
			else if(font==F_6x8)font=F_4x6;
			FontSetSys(font);
			printf("\n\n");
			goto debut;
//mkdir
		case 4:
			if(FOLDER_TABLE==FolderFind(SYMSTR(&argsList[1][1]))){
				printf("\nLe dossier %s existe dj\n",&argsList[1][1]);
			} else{
				FolderAdd(SYMSTR(&argsList[1][1]));
				printf("\nDossier %s cr\n",&argsList[1][1]);
			}
			goto debut;
//clear
		case 5:
			clrscr();
			goto debut;
//dir
		case 6:
			if(!strcmp(dir,"/"))
				SymPtr=SymFindFirst(NULL, 0); // only displays the folders
			else
				SymPtr = SymFindFirst(SYMSTR (dir), FO_SINGLE_FOLDER); //only displays files from current dir
			int ligne=0;
			int nbtot=0;
			int nligmax;
			if(font==F_4x6)nligmax=12;
			else if(font==F_6x8)nligmax=8;
			else nligmax=6;
			printf("\nContenu du rpertoire %s",dir);
			while(SymPtr){
				if (ligne<=nligmax)printf("\n%s", SymPtr);
				else {
					printf("\nAppuyez sur une touche...");
					ngetchx();
					ligne=-1;
					clrscr();
					printf("\n%s",SymPtr);
				}
			  SymPtr = SymFindNext ();
			  nbtot++;
				ligne++;
			}
			printf("\n\nTotal de fichiers : %i\n",nbtot);
			goto debut;
//help
		case 7:
			printf("\nCommandes disponibles : \nclear, dir, exit, help, mv, mkdir, cd, +, -, rm, cp, off, batt, del, echo, ren, run\n");
			goto debut;
//ren
		case 8:
			if(SymMove(SYMSTR(&argsList[1][1]), SYMSTR(&argsList[2][1])))printf("\nLe fichier a bien t renomm\n");
			else printf("\nErreur de renommage du fichier %s\n",&argsList[1][1]);
			goto debut;		
//cp
		case 9:
			sprintf(file,"%s\\%s", dir, &argsList[1][1]);
			sprintf(file_dest,"%s\\%s", &argsList[2][1], &argsList[1][1]);
			cmd_copyvar(SYMSTR(file), SYMSTR(file_dest));
			goto debut;
//del
		case 10:
			printf("\nEffacer le fichier %s ? (o/n)\n", &argsList[1][1]);
			short a;
			char filenam[18];
			sprintf(filenam, "%s\\%s", dir, &argsList[1][1]);
			if((a=ngetchx())=='o' || (a=='O')) SymDel(SYMSTR(filenam));
			goto debut;
//cd
		case 11:
			if ((FOLDER_TABLE==FolderFind(SYMSTR(&argsList[1][1]))) || \
				(MAIN_FOLDER==FolderFind(SYMSTR(&argsList[1][1]))))strncpy(dir, &argsList[1][1], 8);
			else printf("\ncd : nom de rpertoire invalide");
			printf("\n");
			goto debut;
//cd..
		case 12:
			strcpy(dir, "/");
			printf("\n");
			goto debut;
//rm
		case 13:
			if(strcmp(&argsList[1][1], "") && strcmp(&argsList[2][1], "")){
				char filename[18];
				short a;
				if(!strcmp(dir, "/")){		// to delete a folder
					printf("\nEffacer le dossier %s et son contenu?\n", &argsList[1][1]);
					if((a=ngetchx())=='o' || a=='O'){
						if(FolderDel(SYMSTR(arg))!=0)printf("Dossier effac\n");
						else printf("Erreur de suppression du dossier %s\n", &argsList[1][1]);
					}
				}else{									// to delete a file
					sprintf(filename, "%s\\%s", &argsList[2][1], &argsList[1][1]);
					printf("\nEffacer le fichier %s?\n", filename);
					if ((a=ngetchx())==111 || (a==79)){
						if (SymDel(SYMSTR(filename))!=0) printf("Fichier ffac\n");
						else printf("Erreur de suppression\n");
					}
				}
			}else printf("\nUsage : rm <file> <dir>\n");
			goto debut;
//batt
		case 14:
			batt=BatteryState(1);
			float charge=100;
			switch(batt){
				case 0:charge=0; break;
				case 1:charge=14.3; break;
				case 2:charge=28.6; break;
				case 3:charge=42.9; break;
				case 4:charge=57.1; break;
				case 5:charge=71.4; break;
				case 6:charge=85.7; break;
				case 7:charge=100; break;
			}
			printf("\n Niveau de charge : %f %c\n",charge, 37);
			goto debut;
//mv
		case 15:
			file[0]='\0';
			sprintf(file,"%s\\%s", dir, &argsList[1][1]);
			sprintf(file_dest,"%s\\%s", &argsList[2][1], &argsList[1][1]);
			if(SymMove(SYMSTR(file), SYMSTR(file_dest))) printf("\nFichier dplac\n");
			else printf("Erreur de dplacement\n");
			goto debut;
//echo
		case 16:
			printf("\n%s\n", &argsList[1][1]);
			goto debut;
//run
		case 17:
			if(!strcmp(&argsList[1][1], "")){
				printf("\nArgument manquant\n");
				goto debut;
			}
			if(!strcmp(&argsList[1][1], "lin4ti")){
				printf("\nLin4Ti fonctionne deja\n");
				goto debut;
			}
			strcpy(file, &argsList[1][1]);
			strcat(file, "()");
			push_parse_text(file);
			HANDLE h=HS_popEStack();
			exit_from_prog=TRUE;
			printf("\n[pingoui@ti.%s]",dir);
			SaveScrState (&ss);
			TRY
			    NG_execute (h, FALSE);
 			FINALLY
    			HeapFree (h);
		  ENDFINAL
			FontSetSys(font); // can be modified by another prog to F_6x8, we reset it like it was before
			goto debut;
//only <RETURN>
		case 18:
			printf("\n"); goto debut;
//bad command
		case 19:
			printf("\nCommande invalide\n");
			goto debut;
		default:
			break;
	}
	end:
		LCD_restore(LCD_buff);
		ST_showHelp("Bonne journe avec Lin4Ti !");
	return;

}
	asm("BatteryState:\n"
"           movem.l  %d1/%a0-%a1,-(%sp)\n"
"           tst.w   16(%sp)           | jump for HW1\n"
"           beq     _bat_h1_1\n"
"           lea     0x70001D,%a0\n"
"           move.b  (%a0),%d0\n"
"           ori.b   #9,%d0\n"
"           move.b  %d0,(%a0)\n"
"_bat_h1_1: moveq   #6,%d1\n"
"           lea     0x600018,%a1\n"
"_bat_loop: bsr.s   _bat_ini         | this initialization lacked in previous versions\n"
"           move.w  %d1,%d0\n"
"           lsl.w   #7,%d0\n"
"           move.w  %d0,(%a1)\n"
"           moveq   #0x6e,%d0\n"
"_bat_test: btst.b  #2,-0x18(%a1)\n"
"           dbeq    %d0,_bat_test\n"
"           beq.s   _bat_quit\n"
"           dbf     %d1,_bat_loop\n"
"_bat_quit: neg.w   %d1\n"
"           addq.w  #6,%d1\n"
"           tst.w   4(%sp)\n"
"           beq.s   _bat_h1_2        | jump for HW1\n"
"           and.b   #0xF7,(%a0)\n"
"           bsr.s   _bat_ini\n"
"           andi.b  #0xF6,(%a0)\n"
"_bat_h1_2: move.w  %d1,%d0\n"
"           movem.l (%sp)+,%d1/%a0-%a1\n"
"           rts\n"
"_bat_ini:  move.w  #0x380,(%a1)\n"
"           moveq   #52,%d0\n"
"_bat_wait: btst.b  #2,-0x18(%a1)\n"
"           dbeq    %d0,_bat_wait\n"
"           rts");
